'' Debug_Lcd Test (4x20 LCD)
''
'' Author.... Mike Cook
'' Updated... 26 MAY 2007
''
'' Uses the Matrix Orbital 4x20 serial LCD to display a counter in decimal, hex, and binary formats.


CON

  _clkmode = xtal1 + pll16x                             ' use crystal x 16
  _xinfreq = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)

  LCD_PIN   = 7                                         ' for Matrix Orbital 4x20 serial LCD on P9
  LCD_BAUD  = 19_200
  

OBJ

  lcd : "debug_lcd_LCD2041"


PUB main | idx

  if lcd.start(LCD_PIN, LCD_BAUD)                       ' start lcd
    lcd.cursor(0)                                       ' cursor off
    lcd.contrast(150)
    lcd.backLight(TRUE)                                 ' backlight on (if available)
    lcd.custom(0, @Bullet)                              ' create custom character 0
    lcd.cls                                             ' clear the lcd
    lcd.str(string("LCD DEBUG"))
    lcd.gotoxy(1, 2)
    lcd.putc(0)                                         
    lcd.str(string(" Dec"))
    lcd.gotoxy(1, 3)
    lcd.putc(0)
    lcd.str(string(" Hex")) 
    lcd.gotoxy(1, 4)
    lcd.putc(0)
    lcd.str(string(" Bin"))     

    repeat
      lcd.gotoxy(15, 2)
      lcd.putc(32)
      repeat idx from 0 to 4095
        updateLcd(idx)
        waitcnt(clkfreq / 100 + cnt)                      ' pad with 1/5 sec

      repeat idx from -4095 to 0
        updatelcd(idx)
        waitcnt(clkfreq / 100+ cnt)
        

PRI updateLcd(value)

  if value > 0
    lcd.gotoxy(16, 2)
  else
    lcd.gotoxy(15, 2)
      
  lcd.decf(value, 4)                                    ' print right-justified decimal value
  lcd.gotoxy(16, 3)
  lcd.ihex(value, 3)                                    ' print indicated (with $) hex
  lcd.gotoxy(7, 4)
  lcd.ibin(value, 12)                                   ' print indicated (with %) binary                
                
      
DAT

  Bullet      byte      $00, $04, $0E, $1F, $0E, $04, $00, $00

 